unit ReporterRod;

interface

uses Printers,Stdctrls,Dialogs,Windows, Messages, SysUtils, Classes, Controls,
  Graphics,db,IBCustomDataSet, IBQuery;

type
  TCampo=String;
  TSecaoName=String;
  TBordas=(btEsquerda,btDireita,btTopo,btBaixo);
  TBordasSet=Set of TBordas;
  TReporterRod=Class;
  TRepSecoes=Class;
  TRepSecao=Class(TCollectionItem)
  Private
   FName:TSecaoName;
   FTexto:String;
   FFontName:TFontName;
   FFontHeight:Integer;
   FWidth:Integer;
   FHeight:Integer;
   FLeft:Integer;
   FTop:Integer;
   FBordas:TBordasSet;
   FHAlignMent:TAlignment;
   FVAlignMent:TTextLayout;
   FStyle:TFontStyles;
   FFontColor:TColor;
   FCampo:TCampo;
   Procedure SetName(Value:TSecaoName);
   Procedure SetTexto(Value:String);
   Procedure SetFontName(Value:TFontName);
   Procedure SetFontHeight(Value:Integer);
   Procedure SetLeft(Value:Integer);
   Procedure SetTop(Value:Integer);
   Procedure SetWidth(Value:Integer);
   Procedure SetHeight(Value:Integer);
   Procedure SetBordas(Value:TBordasSet);
   Procedure SetHAlignment(Value:TAlignment);
   Procedure SetVAlignment(Value:TTextLayout);
   Procedure SetFontStyles(Value:TFontStyles);
   Procedure SetFontColor(Value:TColor);
   Function  Secoes:TRepSecoes;
  protected
    function GetDisplayName: String; override;
  Public
   constructor Create(Collection: TCollection); override;
   Function RectArea(ACanvas:TCanvas):TRect;
  Published
   Property Nome:TSecaoName Read FName Write SetName;
   Property Texto:String Read FTexto Write SetTexto;
   Property FontName:TFontName Read FFontName Write SetFontName;
   Property FontHeight:Integer Read FFontHeight Write SetFontHeight;
   Property Bordas:TBordasSet Read FBordas Write SetBordas;
   Property HAlignMent:TAlignment Read FHAlignMent Write SetHAlignment;
   Property VAlignMent:TTextLayout REad FVAlignMent Write SetVAlignment;
   Property Left:Integer Read FLeft Write SetLeft;
   Property Top:Integer Read FTop Write SetTop;
   Property Width:Integer Read FWidth Write SetWidth;
   Property Height:Integer read FHeight Write SetHeight;
   Property FontStyle:TFontStyles Read FStyle Write SetFontStyles;
   Property FontColor:TColor Read FFontColor Write SetFontColor;
   Property Campo:TCampo read FCampo write FCampo;
  end;

  TRepSecoes=Class(TCollection)
  Private
   FReporter:TReporterRod;
   Function  GetItem(Index:Integer):TRepSecao;
   Procedure SetItem(Index:Integer;Value:TRepSecao);
   Function  GetByName(Index:String):TRepSecao;
  Public
   Constructor Create(AReporter:TReporterRod);
   Property Items[index:Integer]:TRepSecao Read
     GetItem Write SetItem;default;
   Property ItemsByName[Index:String]:TRepSecao Read
     GetByName;
   procedure Assign(Source: TPersistent); override;
   Property Reporter:TreporterRod Read  FReporter;
  end;

  TDrawSec=Procedure(Canvas:TCanvas;Secao:TRepSecao)of object;

  TReporterRod = class(TGraphicControl)
  private
   Atualizando:Boolean;
   FSecoes:TRepSecoes;
   FZoom:Byte;
   FOndrawSec:TDrawSec;
   fPxFactor:Double;
   fdataSet:TDataSet;
   Procedure SetZoom(Value:Byte);
   Procedure SetPxFactor(value:Double);
   Procedure DrawItem(Acanvas:TCanvas;aIndex:Integer);virtual;
  protected
   Procedure DrawSecoes(Escala:Byte;ACanvas:TCanvas);
   procedure Paint; override;
  public
   Procedure ImportarDados;
   Procedure InvalidateRect(retang:TRect);
   Function XCord(pxs:Integer):Integer;
   Function YCord(pxs:Integer):Integer;
   Procedure IniciarAtualizacao;
   Procedure FinalizarAtualizacao;
   procedure Repaint; override;
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
   Procedure Print;
   Function mouseIn(X,Y:Integer):Integer;
   property Canvas;
  published
   Property DataSet:TDataSet read fdataSet write fdataSet;
   Property Secoes:TRepSecoes Read FSecoes Write FSecoes;
   Property Zoom:Byte Read FZoom Write SetZoom;
   Property FatorResolucao:Double read fPxFactor write  SetPxFactor;
   property PopupMenu;
   Property OnDrawSecao:TDrawSec read FOndrawSec Write FOndrawSec;
   property OnClick;
   property OnDblClick;
   property OnMouseDown;
   property OnMouseMove;
   property OnMouseUp;
  end;
  
var linhadupla:Boolean = false;
    showIds:Boolean;
    
Function MMToPixelHoriz(Handle:HDC;Milimetros:Integer):Real;
Function MMToPixelVert(Handle:HDC;Milimetros:Integer):Real;
Function PixelToMMHoriz(Handle:HDC;Pixels:Integer):Real;
Function PixelToMMVert(Handle:HDC;Pixels:Integer):Real;
Procedure DrawText(Const Text:String;
RectArea:TRect;Canvas:TCanvas;Halign:TAlignment;VAlign:TTextLayout);

procedure Register;
implementation
uses forms,Types;
procedure Register;
begin
  RegisterComponents('BKDados', [TReporterRod]);
end;

Function MMToPixelHoriz(Handle:HDC;Milimetros:Integer):Real;
begin
 Result:=Milimetros*GetDeviceCaps(Handle,LOGPIXELSX)/25.4;
end;

Function MMToPixelVert(Handle:HDC;Milimetros:Integer):Real;
Begin
 Result:=Milimetros*GetDeviceCaps(Handle,LOGPIXELSY)/25.4;
End;

Function PixelToMMHoriz(Handle:HDC;Pixels:Integer):Real;
begin
Result:=GetDeviceCaps(Handle,LOGPIXELSX)/25.4;
Result:=Pixels/(Result+0.000001);
end;

Function PixelToMMVert(Handle:HDC;Pixels:Integer):Real;
begin
Result:=GetDeviceCaps(Handle,LOGPIXELSY)/25.4;
Result:=Pixels/(Result+0.000001);
end;
{---[ TRepSecao ]-------------------------->}
Constructor TrepSecao.Create(Collection:TCollection);
begin
inherited Create(Collection);
FFontName:='Courier New';
FFontHeight:=5;
FHeight:=7;
Fleft:=10;
ftop:=10;
Fwidth:=50;
Bordas:=[btEsquerda,btDireita,btTopo,btBaixo];
end;

Function TRepSecao.Secoes:TRepSecoes;
begin
 Result:=TRepSecoes(Collection);
end;

Procedure TRepSecao.SetName(Value:TSecaoName);
Var a:Integer;
Begin
 Value:=AnsiUpperCase(Value);
 if Value=FName then exit;
 if value='' then
  begin
   FName:='';
   exit;
  end;
 a:=0;
With secoes do
 While a<Secoes.Count do begin
  if a<>Index then
  if Items[a].Nome = value then exit;
  a:=a+1;
 end;
 FName := Value;
end;

Procedure TRepSecao.SetTexto(Value:String);
begin
 if Value = FTexto then exit;
 FTexto := Value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetFontName(Value:TFontName);
Begin
 if FFontName=Value Then exit;
 FFontName:=Value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetFontHeight(Value:Integer);
begin
 if Value = FFontHeight then exit;
 FFontHeight := Value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetBordas(Value:TBordasSet);
Begin
 if value = FBordas then exit;
 FBordas := Value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetHAlignment(Value:TAlignment);
Begin
 if FHAlignMent= value then exit;
 FHAlignMent:=value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetVAlignment(Value:TTextLayout);
begin
 if FVAlignMent = Value then Exit;
 FVAlignMent:=value;
 Secoes.FReporter.Repaint;
end;

Function TRepSecao.GetDisplayName:String;
begin
 if FName>'' then
 Result:=FName Else Result := '-Sem Nome-';
end;

Function TRepSecao.RectArea(ACanvas:TCanvas):TRect;
var mmhz,mmvr:Double;
begin
With Secoes.FReporter,self do begin
if fZoom<25 then
FZoom:=25;
if ACanvas = Printer.Canvas then begin
 mmhz:=MMToPixelHoriz(acanvas.Handle,left);
 mmvr:=MMToPixelVert(acanvas.Handle,Top);
end else
begin
 mmhz:=Secoes.Reporter.fPxFactor*left;
 mmvr:=Secoes.Reporter.fPxFactor*top;
end;
Result.Left:=Round(mmhz*(Zoom/100));
Result.Top:=Round(mmvr*(Zoom/100));
if ACanvas = Printer.Canvas then begin
 mmhz:=MMToPixelHoriz(acanvas.Handle,left+Width);
 mmvr:=MMToPixelVert(acanvas.Handle,Top+Height);
end else
begin
 mmhz:=Secoes.Reporter.fPxFactor*(Width+Left);
 mmvr:=Secoes.Reporter.fPxFactor*(top+Height);
end;
Result.Right:=Round(mmhz*(Zoom/100));
Result.Bottom:=Round(mmvr*(Zoom/100));
end;
end;

Procedure TRepSecao.SetWidth(Value:Integer);
begin
 if fwidth=Value then exit;
 Fwidth:=Value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetHeight(Value:Integer);
Begin
 if FHeight = Value then exit;
 FHeight:=value;
 Secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetLeft(Value:Integer);
begin
if value = FLeft then exit;
fleft:=value;
secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetTop(Value:Integer);
begin
if value = ftop then exit;
ftop:=value;
secoes.FReporter.Repaint;
end;

Procedure TRepSecao.SetFontStyles(Value:TFontStyles);
begin
if value = FStyle then exit;
FStyle:=value;
Secoes.FReporter.Repaint;
end;

Procedure TrepSecao.SetFontColor(Value:TColor);
Begin
if Value=FFontColor then exit;
FFontColor:=value;
Secoes.FReporter.Repaint;
end;
{----[ TRepSecoes ]------------------------>}
Constructor TRepSecoes.Create;
Begin
 inherited Create(TRepSecao);
 FReporter:=AReporter;
end;

Procedure TRepSecoes.Assign(Source:TPersistent);
begin
if source is TRepSecoes then
begin
Clear;
FReporter.IniciarAtualizacao;
While Count < TRepSecoes(Source).Count do
With TRepSecao(Add) do
With TRepSecoes(Source) do
begin
 FName:=Items[index].FName;
 FTexto:=Items[index].FTexto;
 FFontName:=Items[index].FFontName;
 FFontHeight:=Items[index].FFontHeight;
 FWidth:=Items[index].FWidth;
 FHeight:=Items[index].FHeight;
 FLeft:=Items[index].FLeft;
 FTop:=Items[index].FTop;
 FBordas:=Items[index].FBordas;
 FHAlignMent:=Items[index].FHAlignMent;
 FVAlignMent:=Items[index].FVAlignMent;
 FStyle:=Items[index].FStyle;
 FFontColor:=Items[index].FFontColor;
 FCampo:=Items[index].FCampo;
end;
end else inherited Assign(Source);
FReporter.FinalizarAtualizacao;
end;

Procedure TRepSecoes.SetItem(Index:Integer;Value:TRepSecao);
begin
 inherited SetItem(index,Value);
end;

Function TRepSecoes.GetItem(Index:Integer):TRepSecao;
begin
 Result := Inherited GetItem(index) as TRepSecao;
end;

Function TRepSecoes.GetByName(Index:String):TRepSecao;
var a : Integer;
    ln,lr : Integer;
    rx : integer;
    Aindex:String;
Begin
 Aindex := AnsiUpperCase(Index);
 Result := nil;
 a := Count;
 ln := 255;
 lr:=length(index);
 Rx:=-1;
 While a > 0 do
  With items[a-1] do
  begin
   a:=a-1;
   if Copy(Nome,1,lr)=AIndex then
   if length(Nome)<ln then begin
   ln:=length(Nome);
   rx:=a;
   end;
  end;
if rx>=0 then Result:=items[rx];
end;

{---[ TReporterRod ]----------------------->}
Constructor TReporterRod.Create;
begin
inherited Create(Aowner);
FSecoes:=TRepSecoes.Create(Self);
fPxFactor:=3.7619047;
Width:=800;
Height:=1125;
FZoom:=100;
end;

Destructor TReporterRod.Destroy;
begin
 FSecoes.Free;
 inherited Destroy;
end;

Procedure TReporterRod.IniciarAtualizacao;
begin
 Atualizando:=true;
end;

Procedure TReporterRod.FinalizarAtualizacao;
begin
if Atualizando = false then exit;
 Atualizando:=false;
 Repaint;
end;

Procedure TReporterRod.Repaint;
begin
 if Atualizando = false then
 inherited Repaint;
end;

Procedure TReporterRod.Paint;
begin
 Canvas.Brush.Color:=clWhite;
 Canvas.FillRect(self.ClientRect);
 if fzoom<25 then fzoom:=25;
 DrawSecoes(zoom,Canvas);
end;

Procedure TReporterRod.Print;
begin
 Printer.BeginDoc;
   DrawSecoes(100,printer.Canvas);
 Printer.EndDoc;
end;


Procedure TReporterRod.SetZoom(Value:Byte);
begin
if (FZoom = value)or(Value<25)or(Value>200) then exit;
FZoom:=Value;
Repaint;
end;

Procedure DrawText(Const Text:String;
RectArea:TRect;Canvas:TCanvas;
Halign:TAlignment;VAlign:TTextLayout);
Var Sx,Sy:Integer;
    Th:Integer;
    a:Integer;
    p13:Integer;
    Alt:Integer;
    s:String;
begin
Th:=abs(Canvas.Font.Height)+1;
canvas.Font.Pitch:=fpFixed;
Alt:=th;
a:=0;
While a<Length(text) do begin
a:=a+1;
if text[a] =  #13 then
alt:=alt+th;
end;
sy:=1;
if alt<(RectArea.Bottom-RectArea.Top) then
Case VAlign of
tlCenter:sy:=((RectArea.Bottom-RectArea.Top)-alt) div 2;
tlBottom:sy:=((RectArea.Bottom-RectArea.Top)-alt);
end;
s:=text;
s:=s+#13;
p13:=pos(#13,s);
Canvas.Brush.Style:=bsClear;
While p13>0 do begin
sx:=Canvas.TextWidth(Copy(s,1,p13-1));
Case Halign of
taLeftJustify:sx:=1;
taCenter:if sx<RectArea.Right-RectArea.Left then
sx:=((RectArea.Right-RectArea.Left)-sx) div 2 else
sx:=1;
taRightJustify:if sx<RectArea.Right-RectArea.Left then
sx:=((RectArea.Right-RectArea.Left)-sx) else
sx:=1;
end;
Canvas.TextRect(RectArea,sx+RectArea.Left,
RectArea.Top+SY,
Copy(s,1,p13-1));
Delete(s,1,p13+1);
p13:=pos(#13,s);
sy:=sY+th;
end;
Canvas.Brush.Style:=bssolid;
end;

Procedure TReporterRod.DrawItem(Acanvas:TCanvas;aIndex:Integer);
var cena:TRect;
begin
With ACanvas,Secoes.Items[aindex] do begin
cena:=RectArea(ACanvas);
{if cena.Top>297 then if acanvas = printer.Canvas then
begin
 printer.NewPage;
end;}
if acanvas=printer.Canvas then
Font.Height:=round(MMToPixelVert(Handle,
abs(FontHeight))*(zoom / 100)) else
Font.Height:=round((fPxFactor* abs(FontHeight))*(zoom / 100));
Font.Name:=FontName;
Font.Color:=FontColor;
Font.Style:=FStyle;
if (Texto='' )and(ACanvas<>Printer.Canvas)and(ShowIds)and(Campo='') then
DrawText(''''+inttostr(id)+'''',cena,Acanvas,FHAlignMent,FVAlignMent) else
DrawText(Texto,cena,Acanvas,FHAlignMent,FVAlignMent);
{Desenho das bordas}
if linhadupla then canvas.Pen.Width:=2 else
canvas.Pen.Width:=1;
if btEsquerda in Bordas then begin
MoveTo(cena.Left,cena.Top);
LineTo(cena.Left,cena.Bottom);
end;
if btDireita in Bordas then begin
MoveTo(cena.Right,cena.Top);
LineTo(cena.Right,cena.Bottom);
end;
if btTopo in Bordas then begin
MoveTo(cena.Left,cena.Top);
LineTo(cena.Right,cena.Top);
end;
if btBaixo in Bordas then begin
MoveTo(cena.Left,cena.Bottom);
LineTo(cena.Right,cena.Bottom);
end;
if Assigned(onDrawSecao) then
OnDrawSecao(ACanvas,Secoes.Items[aindex]);
{Desenho do texto}
end;
end;

Procedure TReporterRod.DrawSecoes(Escala:Byte;Acanvas:TCanvas);
Var a:Integer;
begin
if fzoom<25 then fzoom:=25;
a:=Secoes.Count;
While a>0 do
begin
a:=a-1;
 DrawItem(ACanvas,a);
end;
end;

Function TReporterRod.mouseIn(x,y:Integer):Integer;
Var a:Integer;
ARect:TRect;
begin
 Result:=-1;
 a:=Secoes.Count;
 while a>0 do begin
 a:=a-1;
 arect:=secoes[a].RectArea(Self.Canvas);
 if (x>=arect.Left)and(x<=arect.Right)and
    (y>=arect.Top)and(y<=arect.Bottom) then begin
    Result:=a;
    Exit;
    end;
 end;
end;

Function TReporterRod.XCord;
begin
if fzoom<25 then fzoom:=25;
if fPxFactor<0 then fPxFactor:=0.01;
Result:=round((pxs/fPxFactor)*(100/zoom));
end;

Function TReporterRod.YCord;
begin
if fPxFactor<0 then fPxFactor:=0.01;
if fzoom<25 then fzoom:=25;
Result:=round((pxs/fPxFactor)*(100/zoom));
end;

Procedure TReporterRod.SetPxFactor(value:Double);
begin
 if fPxFactor = value then exit;
 fPxFactor:=value;
 Repaint;
end;
Procedure TReporterRod.ImportarDados;
var a:integer;
    Field:TField;
begin
if DataSet = nil then exit;
a:=0;
while a<Secoes.Count do
with Secoes[a] do
begin
Texto:='';
if (Campo > '')and(DataSet.Active) then
 begin
  Field:=DataSet.FindField(Campo);
  if Field<> nil then
   Texto:=Field.DisplayText;
 end;
a:=a + 1;
end;
end;

Procedure TReporterRod.InvalidateRect;
var a:Integer;
 area:TRect;
 apv:boolean;
 Function XYInrec(X,Y:Integer;RT:TRect):Boolean;
 begin
  Result:=(X >= RT.Left)and(x<=RT.Right);
  Result:=Result and (Y>=RT.Top)and(y<=RT.Bottom);
 end;
 Function CutRect(rec1,rec2:TRect):Boolean;
 begin
  result:=((rec1.Left>=rec2.Left)and(rec1.Left<=rec2.Right))and
  (((rec1.Top<rec2.Top)and(rec1.Bottom>=rec2.Top)));
  Result:=Result or
  ((rec1.Top >= rec2.Top)and(rec1.Top<=rec2.Bottom))and
  (((rec1.Left<rec2.Left)and(rec1.Right>=rec2.Left)));
 end;
var
 tmp:Trect;
begin
retang.Left:=retang.Left-2;
retang.Top:=retang.Top-2;
retang.Bottom:=retang.Bottom+2;
retang.Right:=retang.Right+2;
Canvas.FillRect(retang);
if fzoom<25 then fzoom:=25;
a:=Secoes.Count;
While a>0 do begin
a:=a-1;
with Secoes[a] do begin
 area:=RectArea(Canvas);
 apv:=XYInrec(area.Left,area.Top,retang);
 apv:=apv or XYInrec(area.Left,area.Bottom,retang);
 apv:=apv or XYInrec(area.Right,area.Top,retang);
 apv:=apv or XYInrec(area.Right,area.Bottom,retang);
 apv:=apv or CutRect(area,retang);
 apv:=apv or CutRect(retang,area);
 if apv then
 DrawItem(self.Canvas,a);
end;
end;
end;
end.
