unit RodEditUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ReporterRod, Menus,
  DesignIntf,DesignEditors, AppEvnts;

type
  TRodEditFrm = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Sobre1: TMenuItem;
    N2: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N1251: TMenuItem;
    N1501: TMenuItem;
    N1751: TMenuItem;
    N2001: TMenuItem;
    N3: TMenuItem;
    Panel3: TPanel;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Deletar1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    edtNome: TEdit;
    edtTopo: TEdit;
    edtEsquerda: TEdit;
    edtLargura: TEdit;
    edtAltura: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    LbCor: TLabel;
    Label9: TLabel;
    cbFonte: TComboBox;
    EdtFntAltura: TEdit;
    cxNegrito: TCheckBox;
    cxItalico: TCheckBox;
    cxTaxado: TCheckBox;
    CxSublinhado: TCheckBox;
    cxTopo: TCheckBox;
    cxEsquerda: TCheckBox;
    cxDireita: TCheckBox;
    cxBaixo: TCheckBox;
    optHorizontal: TRadioGroup;
    optVertical: TRadioGroup;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Memo1: TMemo;
    Label10: TLabel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Bevel3: TBevel;
    Label11: TLabel;
    ComboBox1: TComboBox;
    Label12: TLabel;
    ReporterRod1: TReporterRod;
    ApplicationEvents1: TApplicationEvents;
    procedure ReporterRod1DrawSecao(Canvas: TCanvas; Secao: TRepSecao);
    procedure ReporterRod1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ReporterRod1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure Deletar1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure cxTopoExit(Sender: TObject);
    procedure cxEsquerdaExit(Sender: TObject);
    procedure cxDireitaExit(Sender: TObject);
    procedure cxBaixoExit(Sender: TObject);
    procedure optHorizontalExit(Sender: TObject);
    procedure optVerticalExit(Sender: TObject);
    procedure cbFonteExit(Sender: TObject);
    procedure EdtFntAlturaExit(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cxNegritoExit(Sender: TObject);
    procedure cxItalicoExit(Sender: TObject);
    procedure cxTaxadoExit(Sender: TObject);
    procedure CxSublinhadoExit(Sender: TObject);
    procedure edtNomeExit(Sender: TObject);
    procedure edtTopoExit(Sender: TObject);
    procedure edtEsquerdaExit(Sender: TObject);
    procedure edtLarguraExit(Sender: TObject);
    procedure edtAlturaExit(Sender: TObject);
    procedure ReporterRod1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure Sobre1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtNomeKeyPress(Sender: TObject; var Key: Char);
    procedure ReporterRod1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Select(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
  private
   Selecao:Integer;
   Sx,Sy:Integer;
   ex,ey:Integer;
   draging:boolean;
   dw,dh:Integer;
 Procedure LoadSelecion;
  public
    { Public declarations }
  end;

  TRodRepProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TRodRepEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(const PropertyEditor: IProperty;
      var Continue: Boolean); override;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;


procedure Register;

implementation

uses Types, Math;

{$R *.dfm}

procedure Register;
begin
  RegisterComponents('RODRIGO', [TReporterRod]);
  RegisterComponentEditor(TReporterRod, TRodRepEditor);
  RegisterPropertyEditor(TypeInfo(TRepsecoes), TReporterRod, 'Secoes', TRodRepProperty);
end;

{Editor de Relatorio}
procedure TRodRepProperty.Edit;
Var Secoes:TRepSecoes;
    RodFrm:TRodEditFrm;
begin
Secoes:=TRepSecoes(GetOrdValue);
RodFrm:=TRodEditFrm.Create(Application);
Try
With Secoes.Reporter DO begin
  RodFrm.ReporterRod1.DataSet:=DataSet;
  RodFrm.ReporterRod1.SetBounds(0,0,Width,Height);
  RodFrm.ReporterRod1.FatorResolucao:=FatorResolucao;
end;
 RodFrm.ReporterRod1.Secoes.Assign(Secoes);
if RodFrm.ShowModal = mrok then
begin
 Secoes.Assign(RodFrm.ReporterRod1.Secoes);
 Secoes.Reporter.Parent.Left:=Secoes.Reporter.Parent.Left+1;
 Secoes.Reporter.Parent.Left:=Secoes.Reporter.Parent.Left-1;
end;
finally
 RodFrm.Free;
end;
end;

function TRodRepProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{Editor da propriedade TSecoes}
procedure TRodRepEditor.EditProperty(const PropertyEditor: IProperty;
  var Continue: Boolean);
var
  PropName: string;
begin
  PropName := PropertyEditor.GetName;
  if (CompareText(PropName, 'Secoes') = 0) then
  begin
 PropertyEditor.Edit;
 Continue := False;
 end;
end;

Procedure TRodRepEditor.ExecuteVerb(Index:Integer);
begin
  if Index = 0 then  Edit;
end;

Function TRodRepEditor.GetVerbCount:Integer;
begin
Result:=1;
end;

function TRodRepEditor.GetVerb(Index:Integer):String;
begin
  if Index = 0 then
    Result := 'Editar Secoes'
  else Result := '';
end;
{Formulario de Edio}
procedure TRodEditFrm.ReporterRod1DrawSecao(Canvas: TCanvas;
  Secao: TRepSecao);
Var ARect:TRect;
begin
if secao.Index= selecao then
begin
 Canvas.Pen.Color:=clBlue;
 ARect:=Secao.RectArea(Canvas);
 Canvas.Brush.Style:=bsclear;
 canvas.Pen.Width:=2;
 Canvas.Rectangle(secao.rectarea(Canvas));
 Canvas.Brush.Style:=bsSolid;
 Canvas.Pen.Color:=clBlack;
 canvas.Pen.Width:=1;
end;
end;
var refx:Integer=0;
    refy:Integer=0;
    isdown:boolean=false;
    movingv:boolean=false;
    movingH:boolean=false;
procedure TRodEditFrm.ReporterRod1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var sl:Integer;
    arect:TRect;
begin
movingv:=false;
movingH:=false;
refx:=-1;
refy:=-1;
isdown:=false;
if ActiveControl is TEdit then
With ActiveControl as TEdit do
if Assigned(onexit) then
OnExit(ActiveControl as TEdit);
draging:=false;
sl:=ReporterRod1.mouseIn(x,y);
Sx:=x;
sy:=y;
if sl>=0 then
begin
Selecao:=sl;
With ReporterRod1.Secoes[selecao] do begin
 Label11.Caption:=''''+IntToStr(ID)+'''';
 arect:=RectArea(ReporterRod1.Canvas);
 refx:=x-arect.Left;
 refy:=Y-arect.Top;
 if refx+arect.Left+3>=arect.Right then
  Screen.cursor:=crHSplit else
 if refy+arect.Top+3>=arect.Bottom then
   Screen.cursor:=crVSplit;
end;
isdown:=true;
ReporterRod1.Repaint;
exit;
end;
draging:=true;
end;

procedure TRodEditFrm.ReporterRod1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var dx,dy:Integer;
begin

movingv:=false;
movingH:=false;
Screen.cursor:=crDefault;
isdown:=false;
if draging then begin
ex:=X;
ey:=y;
if (sx<ex)and(sy<ey) then
With ReporterRod1.Secoes.Add as TRepSecao do begin
Left:=ReporterRod1.XCord(Sx);
Top:=ReporterRod1.YCord(sy);
Width:=ReporterRod1.XCord(abs(ex-sx));
Height:=ReporterRod1.YCord(abs(ey-Sy));
Selecao:=Index;
end;
end else
{if CheckBox1.Checked then
if ReporterRod1.Secoes.Count>selecao then
With ReporterRod1.Secoes[selecao] do
begin
dx:=Rectarea(ReporterRod1.canvas).Left;
dy:=rectarea(ReporterRod1.canvas).Top;
Left:=ReporterRod1.XCord(dx+(x-sx));
Top:=ReporterRod1.yCord(dy+(y-sy));
end;}
LoadSelecion;
ReporterRod1.FinalizarAtualizacao;
end;

procedure TRodEditFrm.FormCreate(Sender: TObject);
begin
ScrollBox1.DoubleBuffered:=true;
cbFonte.Items.Assign(screen.Fonts);
cbFonte.ItemIndex:=0;
end;

procedure TRodEditFrm.N1001Click(Sender: TObject);
begin
ReporterRod1.Zoom:=TMenuItem(Sender).Tag;
TMenuItem(Sender).Checked:=true;
ReporterRod1.Width:=
(dw*ReporterRod1.Zoom)div 100;
ReporterRod1.Height:=
(dh*ReporterRod1.Zoom)div 100;
end;

procedure TRodEditFrm.Deletar1Click(Sender: TObject);
begin
if ReporterRod1.Secoes.Count>Selecao then
ReporterRod1.Secoes.Delete(Selecao);
if ReporterRod1.Secoes.Count<=Selecao then
Selecao:=0;
ReporterRod1.Repaint;
end;

procedure TRodEditFrm.BitBtn4Click(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

procedure TRodEditFrm.BitBtn5Click(Sender: TObject);
begin
ModalResult:=mrcancel;
end;

Procedure TRodEditFrm.LoadSelecion;
var a:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[selecao] do begin
Label11.Caption:=''''+IntToStr(ID)+'''';
a:=ComboBox1.Items.IndexOf(Campo);
if a>=0 then
ComboBox1.ItemIndex:=a else
ComboBox1.ItemIndex:=0;
edtNome.Text:=Nome;
edtTopo.Text:=inttostr(Top);
edtEsquerda.Text:=inttostr(Left);
edtLargura.Text:=inttostr(Width);
edtAltura.Text:=inttostr(Height);
cbFonte.ItemIndex:=cbFonte.Items.IndexOf(
FontName);
EdtFntAltura.Text:=inttostr(FontHeight);
LbCor.Color:=FontColor;
cxNegrito.Checked:=fsbold in FontStyle;
cxItalico.Checked:=fsitalic in FontStyle;
cxTaxado.Checked:=fsStrikeOut in FontStyle;
CxSublinhado.Checked:=fsUnderline in FontStyle;
cxTopo.Checked:=btTopo in bordas;
cxEsquerda.Checked:=btEsquerda in bordas;
cxDireita.Checked:=btDireita in Bordas;
cxBaixo.Checked:=btBaixo in bordas;
With optHorizontal do
Case HAlignMent of
taLeftJustify:ItemIndex:=0;
taCenter:ItemIndex:=1;
taRightJustify:ItemIndex:=2;
end;
With optVertical do
Case VAlignMent of
tlTop:ItemIndex:=0;
tlCenter:ItemIndex:=1;
tlBottom:ItemIndex:=2;
end;
memo1.Text:=Texto;
With ReporterRod1 do
With Secoes[Selecao] do
label8.Caption:='( '+inttostr(rectarea(ReporterRod1.canvas).Left)+' , '+
inttostr(rectarea(ReporterRod1.Canvas).Top)+' ) - ( '+
inttostr(rectarea(ReporterRod1.Canvas).Right)+' , '+
inttostr(rectarea(ReporterRod1.Canvas).Bottom)+' )';
end;
end;

procedure TRodEditFrm.Memo1Exit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
ReporterRod1.Secoes[selecao].Texto:=memo1.Text;
end;

procedure TRodEditFrm.cxTopoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
if TCheckBox(Sender).Checked then
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas+[bttopo] else
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas-[bttopo];
end;

procedure TRodEditFrm.cxEsquerdaExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
if TCheckBox(Sender).Checked then
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas+[btesquerda] else
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas-[btesquerda];
end;

procedure TRodEditFrm.cxDireitaExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
if TCheckBox(Sender).Checked then
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas+[btDireita] else
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas-[btDireita];
end;

procedure TRodEditFrm.cxBaixoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
if TCheckBox(Sender).Checked then
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas+[btBaixo] else
ReporterRod1.Secoes[selecao].Bordas:=
ReporterRod1.Secoes[selecao].Bordas-[btBaixo];
end;

procedure TRodEditFrm.optHorizontalExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if TCheckBox(Sender).Checked then
Case TRadioGroup(Sender).ItemIndex of
0:HAlignMent:=taLeftJustify;
1:HAlignMent:=taCenter;
2:HAlignMent:=taRightJustify;
end;
end;

procedure TRodEditFrm.optVerticalExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if TCheckBox(Sender).Checked then
Case TRadioGroup(Sender).ItemIndex of
0:VAlignMent:=tlTop;
1:VAlignMent:=tlCenter;
2:VAlignMent:=tlBottom;
end;

end;

procedure TRodEditFrm.cbFonteExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
FontName:=cbFonte.Text;
end;

procedure TRodEditFrm.EdtFntAlturaExit(Sender: TObject);
Var inteiro:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if TryStrToInt(EdtFntAltura.Text,inteiro) then
FontHeight:=inteiro;
end;

procedure TRodEditFrm.BitBtn1Click(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With TColorDialog.Create(Application) do begin
Color:=LbCor.Color;
if Execute then
LbCor.Color:=Color;
ReporterRod1.Secoes[Selecao].FontColor:=LbCor.Color;
free;
end;


end;

procedure TRodEditFrm.cxNegritoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if cxNegrito.Checked then
FontStyle:=FontStyle+[fsBold] else
FontStyle:=FontStyle-[fsBold];
end;

procedure TRodEditFrm.cxItalicoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if cxItalico.Checked then
FontStyle:=FontStyle+[fsitalic] else
FontStyle:=FontStyle-[fsitalic];
end;

procedure TRodEditFrm.cxTaxadoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if cxTaxado.Checked then
FontStyle:=FontStyle+[fsStrikeOut] else
FontStyle:=FontStyle-[fsStrikeOut];
end;

procedure TRodEditFrm.CxSublinhadoExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
if CxSublinhado.Checked then
FontStyle:=FontStyle+[fsUnderline] else
FontStyle:=FontStyle-[fsUnderLine];
end;

procedure TRodEditFrm.edtNomeExit(Sender: TObject);
begin
if selecao<ReporterRod1.Secoes.Count then
With ReporterRod1.Secoes[Selecao] do
Nome:=edtNome.Text;
end;

procedure TRodEditFrm.edtTopoExit(Sender: TObject);
Var Number:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
if TryStrToInt(TEdit(Sender).Text,Number) then
if Number>=0 then
With ReporterRod1.Secoes[Selecao] do
Top:=Number;
end;

procedure TRodEditFrm.edtEsquerdaExit(Sender: TObject);
Var Number:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
if TryStrToInt(TEdit(Sender).Text,Number) then
if Number>=0 then
With ReporterRod1.Secoes[Selecao] do
Left:=Number;
end;

procedure TRodEditFrm.edtLarguraExit(Sender: TObject);
Var Number:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
if TryStrToInt(TEdit(Sender).Text,Number) then
if Number>=0 then
With ReporterRod1.Secoes[Selecao] do
Width:=Number;
end;

procedure TRodEditFrm.edtAlturaExit(Sender: TObject);
Var Number:Integer;
begin
if selecao<ReporterRod1.Secoes.Count then
if TryStrToInt(TEdit(Sender).Text,Number) then
if Number>=0 then
With ReporterRod1.Secoes[Selecao] do
Height:=Number;
end;

procedure TRodEditFrm.ReporterRod1Click(Sender: TObject);
begin
LoadSelecion;
end;

procedure TRodEditFrm.BitBtn2Click(Sender: TObject);
begin
if selecao>0 then Dec(Selecao);
LoadSelecion;
ReporterRod1.Repaint;
end;

procedure TRodEditFrm.BitBtn3Click(Sender: TObject);
begin
if Selecao+1<ReporterRod1.Secoes.Count then
inc(Selecao);
LoadSelecion;
ReporterRod1.Repaint;
end;

procedure TRodEditFrm.N2Click(Sender: TObject);
begin
N501.Checked:=ReporterRod1.Zoom=N501.Tag;
N751.Checked:=ReporterRod1.Zoom=N751.Tag;
N1001.Checked:=ReporterRod1.Zoom=N1001.Tag;
N1251.Checked:=ReporterRod1.Zoom=N1251.Tag;
N1501.Checked:=ReporterRod1.Zoom=N1501.Tag;
N1751.Checked:=ReporterRod1.Zoom=N1751.Tag;
N2001.Checked:=ReporterRod1.Zoom=N2001.Tag;
end;

procedure TRodEditFrm.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
begin
Handled:=PopupMenu1.IsShortCut(Msg);
end;

procedure TRodEditFrm.Sobre1Click(Sender: TObject);
begin
ShowMessage('Feito por Rodrigo Antonio de Araujo !');
end;

procedure TRodEditFrm.FormShow(Sender: TObject);
Var a:Integer;
begin
 showIds:=true;
 SetBounds(0,0,Screen.Width,Screen.Height);
 dw := ReporterRod1.Width;
 dh := ReporterRod1.Height;
 ReporterRod1.ImportarDados;
 a:=0;
 if ReporterRod1.DataSet<>nil then
 while a<ReporterRod1.DataSet.FieldCount do
 with ReporterRod1.DataSet.Fields[a] do
 begin
  ComboBox1.Items.Add(FieldName);
  a:=a + 1;
 end;
 ComboBox1.ItemIndex:=0;
end;

procedure TRodEditFrm.edtNomeKeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then begin
key:=#0;
if Assigned(Tedit(Sender).OnExit) then
Tedit(Sender).OnExit(Tedit(Sender));
Tedit(Sender).SelectAll;
end;
end;

procedure TRodEditFrm.ReporterRod1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var dx,dy:Integer;
    vx,vy:Integer;
    aumento:integer;
    arect:TRect;
begin
Caption:='RodReporter Editor By Rodrigo at 04/06/2005 '+
'( '+inttostr(ReporterRod1.XCord(X))+' , '+
inttostr(ReporterRod1.yCord(y))+' )';
if isdown then
if (draging = false)and(CheckBox1.Checked)or(movingv)or(movingH) then
begin
if (ReporterRod1.Secoes.Count>selecao)and(Selecao>=0) then
With ReporterRod1.Secoes[selecao] do
begin
ReporterRod1.IniciarAtualizacao;
arect:=RectArea(ReporterRod1.Canvas);
 if (refx+arect.Left+3>=arect.Right)or(movingH) then begin
  movingH:=true;
  Screen.cursor:=crHSplit;
  Width:=ReporterRod1.XCord(x-arect.Left);
  edtLargura.Text:=IntToStr(Width);
 end else
 if (refy+arect.Top+3>=arect.Bottom)or(movingv) then
 begin
  movingv:=true;
  Screen.cursor:=crVSplit;
  Height:=ReporterRod1.XCord(Y-arect.Top);
  edtAltura.Text:=IntToStr(Height);
 end else begin
 Left:=ReporterRod1.XCord(x-refx);
 Top:=ReporterRod1.yCord(y-refy);
 end;
  ReporterRod1.InvalidateRect(arect);
  arect:=RectArea(ReporterRod1.Canvas);
  ReporterRod1.InvalidateRect(arect);
end;
LoadSelecion;
ReporterRod1.Repaint;
end;
end;

procedure TRodEditFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
showIds:=false;
end;

procedure TRodEditFrm.ComboBox1Select(Sender: TObject);
begin
if Selecao>=ReporterRod1.Secoes.Count then exit;
if Selecao<0 then exit;
with ReporterRod1.Secoes[Selecao] do
if pos('**',ComboBox1.Text)>0 then
Campo:='' else
Campo:=ComboBox1.Text;
ReporterRod1.ImportarDados;
LoadSelecion;
end;

procedure TRodEditFrm.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
 case msg.message of
   WM_MOUSEWHEEL:
   begin
    if ActiveControl = ComboBox1 then exit;
     Handled:=true;
     if(msg.wParam < 0) then
     ScrollBox1.VertScrollBar.Position:=
     ScrollBox1.VertScrollBar.Position+22 else
     ScrollBox1.VertScrollBar.Position:=
     ScrollBox1.VertScrollBar.Position-22;
  end;
 end;
end;

end.
